"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var config = _interopRequireWildcard(require("./config"));

var _request = _interopRequireDefault(require("./request"));

var _aws_group = _interopRequireDefault(require("./services/aws_group"));

var _aws_group_roll = _interopRequireDefault(require("./services/aws_group_roll"));

var _aws_instance = _interopRequireDefault(require("./services/aws_instance"));

var _aws_spot = _interopRequireDefault(require("./services/aws_spot"));

var _subscription = _interopRequireDefault(require("./services/subscription"));

var _spectrum = _interopRequireDefault(require("./services/spectrum"));

var _functions = _interopRequireDefault(require("./services/functions"));

var _endpoints = _interopRequireDefault(require("./services/endpoints"));

var _aws_emr = _interopRequireDefault(require("./services/mrscaler/aws_emr"));

var _debug = _interopRequireDefault(require("debug"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Client = /*#__PURE__*/function () {
  function Client() {
    _classCallCheck(this, Client);

    this._debug = (0, _debug["default"])("".concat(config.SDKName, ":client"));
    this._config = this._defaultConfig();

    for (var _len = arguments.length, opts = new Array(_len), _key = 0; _key < _len; _key++) {
      opts[_key] = arguments[_key];
    }

    for (var _i = 0, _opts = opts; _i < _opts.length; _i++) {
      var opt = _opts[_i];
      opt.call(this, this._config);
    }

    if (this._config.accountId == undefined) {
      if (process.env.SPOTINST_ACCOUNT) {
        this._config.accountId = process.env.SPOTINST_ACCOUNT;
      }
    }

    if (this._config.credentials == undefined) {
      if (process.env.SPOTINST_TOKEN) {
        this._config.credentials = {
          token: process.env.SPOTINST_TOKEN
        };
      }
    }

    this.AwsGroupService = new _aws_group["default"](this);
    this.AwsGroupRollService = new _aws_group_roll["default"](this);
    this.AwsInstanceService = new _aws_instance["default"](this);
    this.AwsSpotService = new _aws_spot["default"](this);
    this.SubscriptionService = new _subscription["default"](this);
    this.FunctionsService = new _functions["default"](this);
    this.SpectrumService = new _spectrum["default"](this);
    this.EndpointService = new _endpoints["default"](this);
    this.MrScalerAwsService = new _aws_emr["default"](this);
  }
  /**
   * _defaultConfig returns the default configuration for the client.
   * @returns {{apiAddress, oauthAddress, scheme, userAgent, contentType, httpClient}}
   * @private
   */


  _createClass(Client, [{
    key: "_defaultConfig",
    value: function _defaultConfig() {
      return {
        apiAddress: config.DefaultAPIAddress,
        oauthAddress: config.DefaultOAuthAddress,
        scheme: config.DefaultScheme,
        userAgent: config.DefaultUserAgent,
        contentType: config.DefaultContentType,
        httpClient: config.DefaultHttpClient,
        httpTimeout: config.DefaultHttpTimeout
      };
    }
    /**
     * _newRequest is used to create a new request.
     * @param method
     * @param path
     * @param body
     * @param params
     * @returns {Request}
     * @private
     */

  }, {
    key: "_newRequest",
    value: function _newRequest(method, path, body) {
      var params = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

      if (!method || !method.length) {
        throw new Error("spotinst-sdk-nodejs: invalid or malformed method");
      }

      if (!path || !path.length) {
        throw new Error("spotinst-sdk-nodejs: invalid or malformed path");
      }

      var options = {
        config: this._config,
        url: "".concat(this._config.scheme, "://").concat(this._config.apiAddress).concat(path),
        method: method,
        body: body,
        params: params
      };

      if (this._config.credentials) {
        options.headers = _objectSpread({}, options.headers, {
          Authorization: "Bearer ".concat(this._config.credentials.token)
        });
      }

      if (this._config.accountId && !options.params.accountId) {
        options.params.accountId = this._config.accountId;
      }

      var request = new _request["default"](options);
      return request;
    }
    /**
     * _doRequest runs a request with our client.
     * @param request
     * @returns {Promise}
     * @private
     */

  }, {
    key: "_doRequest",
    value: function _doRequest(request) {
      var _this = this;

      return new Promise(function (resolve, reject) {
        _this._debug("converting to http request");

        var req = request._toHTTP();

        _this._dumpRequest(req);

        _this._debug("calling http client");

        return _this._config.httpClient["do"](req).then(function (res) {
          _this._debug("promise resolved");

          _this._dumpResponse(res);

          resolve(res);
        })["catch"](function (err) {
          _this._debug("promise rejected", err);

          reject(err.toString());
        });
      });
    }
    /**
     * _requireOK is used to verify response status code is a successful one.
     * @param request
     * @returns {Promise}
     * @private
     */

  }, {
    key: "_requireOK",
    value: function _requireOK(request) {
      return new Promise(function (resolve, reject) {
        request.then(function (res) {
          /^2/.test("" + res.statusCode) ? resolve(res.body) : reject(res);
        })["catch"](function (err) {
          return reject(err);
        });
      });
    }
    /**
     * _dumpRequest dumps the given HTTP request to the trace log.
     * @param request
     * @private
     */

  }, {
    key: "_dumpRequest",
    value: function _dumpRequest(request) {
      try {
        this._debug("request:", request);
      } catch (err) {}
    }
    /**
     * _dumpResponse dumps the given HTTP response to the trace log.
     * @param response
     * @private
     */

  }, {
    key: "_dumpResponse",
    value: function _dumpResponse(response) {
      try {
        this._debug("response:", JSON.stringify(response.toJSON(), null, 2));
      } catch (err) {}
    }
  }]);

  return Client;
}();

exports["default"] = Client;