"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _config = require("./config");

var _debug = _interopRequireDefault(require("debug"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

/**
 * Default request options.
 * @type {{config: {}, method: string, url: string, body: null, params: {}, headers: {}}}
 */
var defaultOpts = {
  config: {},
  method: "",
  url: "",
  body: null,
  params: {},
  headers: {}
};

var Request = /*#__PURE__*/function () {
  function Request() {
    var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultOpts;

    _classCallCheck(this, Request);

    this._debug = (0, _debug["default"])("".concat(_config.SDKName, ":request"));
    this._opts = opts;
  }
  /**
   * toHTTP converts the request to an HTTP request.
   * @returns {method: string, uri: string, headers: ...}
   * @private
   */


  _createClass(Request, [{
    key: "_toHTTP",
    value: function _toHTTP() {
      this._debug("converting to http request");

      return {
        method: this._opts.method.toUpperCase(),
        uri: this._opts.url,
        headers: _objectSpread({}, this._opts.headers, {
          "Content-Type": this._opts.config.contentType,
          Accept: this._opts.config.contentType,
          "User-Agent": this._opts.config.userAgent
        }),
        qs: this._opts.params,
        body: this._opts.body || this.body,
        timeout: this._opts.config.httpTimeout,
        json: true,
        resolveWithFullResponse: true
      };
    }
  }]);

  return Request;
}();

exports["default"] = Request;