"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _config = require("../config");

var _util = _interopRequireDefault(require("../util"));

var _debug = _interopRequireDefault(require("debug"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var AwsGroupService = /*#__PURE__*/function () {
  function AwsGroupService(client) {
    _classCallCheck(this, AwsGroupService);

    this._debug = (0, _debug["default"])("".concat(_config.SDKName, ":aws_group"));
    this._client = client;
    this._basePath = "/aws/ec2/group";
  }
  /**
   * list describes all the groups.
   * @param params
   * @returns {Promise}
   */


  _createClass(AwsGroupService, [{
    key: "list",
    value: function list() {
      var _this = this;

      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var callback = arguments.length > 1 ? arguments[1] : undefined;
      return new Promise(function (resolve, reject) {
        _this._debug("initiating a new list request");

        var req = _this._client._newRequest("GET", _this._basePath);

        _this._debug("making list request");

        _this._client._requireOK(_this._client._doRequest(req)).then(function (res) {
          _this._debug("promise resolved");

          _util["default"].resolveOnSuccess(res.response.items, callback, resolve);
        })["catch"](function (err) {
          _this._debug("promise rejected", err);

          _util["default"].rejectOnFailure(err.toString(), callback, reject);
        });
      });
    }
    /**
     * create creates a new group.
     * @param params
     * @returns {Promise}
     */

  }, {
    key: "create",
    value: function create() {
      var _this2 = this;

      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var callback = arguments.length > 1 ? arguments[1] : undefined;
      return new Promise(function (resolve, reject) {
        if (!params.group) {
          params = {
            group: _objectSpread({}, params)
          };
        }

        _this2._debug("initiating a new create request");

        _this2._debug("preparing body");

        var body = {
          group: Object.assign({}, params.group)
        };

        _this2._debug("body=", body);

        var req = _this2._client._newRequest("POST", _this2._basePath, body);

        _this2._debug("making create request");

        _this2._client._requireOK(_this2._client._doRequest(req)).then(function (res) {
          _this2._debug("promise resolved");

          _util["default"].resolveOnSuccess(res.response.items, callback, resolve);
        })["catch"](function (err) {
          _this2._debug("promise rejected", err);

          _util["default"].rejectOnFailure(err.toString(), callback, reject);
        });
      });
    }
    /**
     * read describes a specific group.
     * @param params
     * @returns {Promise}
     */

  }, {
    key: "read",
    value: function read() {
      var _this3 = this;

      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var callback = arguments.length > 1 ? arguments[1] : undefined;
      return new Promise(function (resolve, reject) {
        if (!_util["default"].isValid("id", params.id, callback, reject)) return;

        _this3._debug("initiating a new read request, id=", params.id);

        var req = _this3._client._newRequest("GET", "".concat(_this3._basePath, "/").concat(params.id));

        _this3._debug("making read request");

        _this3._client._requireOK(_this3._client._doRequest(req)).then(function (res) {
          _this3._debug("promise resolved");

          _util["default"].resolveOnSuccess(res.response.items, callback, resolve);
        })["catch"](function (err) {
          _this3._debug("promise rejected", err);

          _util["default"].rejectOnFailure(err.toString(), callback, reject);
        });
      });
    }
    /**
     * update updates an existing group.
     * @param params
     * @returns {Promise}
     */

  }, {
    key: "update",
    value: function update() {
      var _this4 = this;

      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var callback = arguments.length > 1 ? arguments[1] : undefined;
      return new Promise(function (resolve, reject) {
        if (!params.group) {
          params = {
            group: _objectSpread({}, params)
          };
        }

        _this4._debug("initiating a new update request, id=", params.group.id);

        _this4._debug("preparing body");

        var body = {
          group: Object.assign({}, params.group)
        };
        delete body.group.id;

        _this4._debug("body=", body);

        var req = _this4._client._newRequest("PUT", "".concat(_this4._basePath, "/").concat(params.group.id), body);

        _this4._debug("making update request");

        _this4._client._requireOK(_this4._client._doRequest(req)).then(function (res) {
          _this4._debug("promise resolved");

          _util["default"].resolveOnSuccess(res.response.items, callback, resolve);
        })["catch"](function (err) {
          _this4._debug("promise rejected", err);

          _util["default"].rejectOnFailure(err.toString(), callback, reject);
        });
      });
    }
    /**
     * delete deletes an existing group.
     * @param params
     * @returns {Promise}
     */

  }, {
    key: "delete",
    value: function _delete() {
      var _this5 = this;

      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var callback = arguments.length > 1 ? arguments[1] : undefined;
      return new Promise(function (resolve, reject) {
        if (!_util["default"].isValid("id", params.id, callback, reject)) return;

        _this5._debug("initiating a new delete request, id=", params.id);

        var req = _this5._client._newRequest("DELETE", "".concat(_this5._basePath, "/").concat(params.id));

        _this5._debug("making delete request");

        _this5._client._requireOK(_this5._client._doRequest(req)).then(function (res) {
          _this5._debug("promise resolved");

          _util["default"].resolveOnSuccess(res.response.items, callback, resolve);
        })["catch"](function (err) {
          _this5._debug("promise rejected", err);

          _util["default"].rejectOnFailure(err.toString(), callback, reject);
        });
      });
    }
    /**
     * status describes the current status of a specific group.
     * @param params
     * @returns {Promise}
     */

  }, {
    key: "status",
    value: function status() {
      var _this6 = this;

      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var callback = arguments.length > 1 ? arguments[1] : undefined;
      return new Promise(function (resolve, reject) {
        if (!_util["default"].isValid("id", params.id, callback, reject)) return;

        _this6._debug("initiating a new status request, id=", params.id);

        var req = _this6._client._newRequest("GET", "".concat(_this6._basePath, "/").concat(params.id, "/status"));

        _this6._debug("making status request");

        _this6._client._requireOK(_this6._client._doRequest(req)).then(function (res) {
          _this6._debug("promise resolved");

          _util["default"].resolveOnSuccess(res.response.items, callback, resolve);
        })["catch"](function (err) {
          _this6._debug("promise rejected", err);

          _util["default"].rejectOnFailure(err.toString(), callback, reject);
        });
      });
    }
  }]);

  return AwsGroupService;
}();

exports["default"] = AwsGroupService;