"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _config = require("../config");

var _util = _interopRequireDefault(require("../util"));

var _debug = _interopRequireDefault(require("debug"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var AwsInstanceService = /*#__PURE__*/function () {
  function AwsInstanceService(client) {
    _classCallCheck(this, AwsInstanceService);

    this._debug = (0, _debug["default"])("".concat(_config.SDKName, ":aws_instance"));
    this._client = client;
    this._basePath = "/aws/ec2/instance";
  }
  /**
   * read describes a specific instance.
   * @param params
   * @returns {Promise}
   */


  _createClass(AwsInstanceService, [{
    key: "read",
    value: function read() {
      var _this = this;

      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var callback = arguments.length > 1 ? arguments[1] : undefined;
      return new Promise(function (resolve, reject) {
        _this._debug("initiating a new read request, id=", params.id);

        if (!_util["default"].isValid("id", params.id, callback, reject)) return;

        var req = _this._client._newRequest("GET", "".concat(_this._basePath, "/").concat(params.id));

        _this._debug("making read request");

        _this._client._requireOK(_this._client._doRequest(req)).then(function (res) {
          _this._debug("promise resolved");

          _util["default"].resolveOnSuccess(res.response.items, callback, resolve);
        })["catch"](function (err) {
          _this._debug("promise rejected", err);

          _util["default"].rejectOnFailure(err.toString(), callback, reject);
        });
      });
    }
    /**
     * detach detaches a specific instance from an existing group.
     * @param params
     * @returns {Promise}
     */

  }, {
    key: "detach",
    value: function detach() {
      var _this2 = this;

      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var callback = arguments.length > 1 ? arguments[1] : undefined;
      return new Promise(function (resolve, reject) {
        _this2._debug("initiating a new detach request, params=", params);

        _this2._debug("preparing body");

        var body = Object.assign({}, params);

        _this2._debug("body=", body);

        var req = _this2._client._newRequest("PUT", "".concat(_this2._basePath, "/detach"), body);

        _this2._debug("making detach request");

        _this2._client._requireOK(_this2._client._doRequest(req)).then(function (res) {
          _this2._debug("promise resolved");

          _util["default"].resolveOnSuccess(null, callback, resolve);
        })["catch"](function (err) {
          _this2._debug("promise rejected", err);

          _util["default"].rejectOnFailure(err.toString(), callback, reject);
        });
      });
    }
    /**
     * signal notifies about the state of a specific instance.
     * @param params
     * @returns {Promise}
     */

  }, {
    key: "signal",
    value: function signal() {
      var _this3 = this;

      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var callback = arguments.length > 1 ? arguments[1] : undefined;
      return new Promise(function (resolve, reject) {
        _this3._debug("initiating a new signal request, params=", params);

        _this3._debug("preparing body");

        var body = Object.assign({}, params);

        _this3._debug("body=", body);

        var req = _this3._client._newRequest("POST", "".concat(_this3._basePath, "/signal"), body);

        _this3._debug("making signal request");

        _this3._client._requireOK(_this3._client._doRequest(req)).then(function (res) {
          _this3._debug("promise resolved");

          _util["default"].resolveOnSuccess(null, callback, resolve);
        })["catch"](function (err) {
          _this3._debug("promise rejected", err);

          _util["default"].rejectOnFailure(err.toString(), callback, reject);
        });
      });
    }
  }]);

  return AwsInstanceService;
}();

exports["default"] = AwsInstanceService;