"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _config = require("../config");

var _util = _interopRequireDefault(require("../util"));

var _debug = _interopRequireDefault(require("debug"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var AwsSpotService = /*#__PURE__*/function () {
  function AwsSpotService(client) {
    _classCallCheck(this, AwsSpotService);

    this._debug = (0, _debug["default"])("".concat(_config.SDKName, ":aws_spot"));
    this._client = client;
    this._basePath = "/aws/ec2/spot";
  }
  /**
   * read describes a specific Spot Instance Request.
   * @param params
   * @returns {Promise}
   */


  _createClass(AwsSpotService, [{
    key: "read",
    value: function read() {
      var _this = this;

      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var callback = arguments.length > 1 ? arguments[1] : undefined;
      return new Promise(function (resolve, reject) {
        if (!_util["default"].isValid("id", params.id, callback, reject)) return;

        _this._debug("initiating a new read request, id=", params.id);

        var req = _this._client._newRequest("GET", "".concat(_this._basePath, "/").concat(params.id));

        _this._debug("making read request");

        _this._client._requireOK(_this._client._doRequest(req)).then(function (res) {
          _this._debug("promise resolved");

          _util["default"].resolveOnSuccess(res.response.items, callback, resolve);
        })["catch"](function (err) {
          _this._debug("promise rejected", err);

          _util["default"].rejectOnFailure(err.toString(), callback, reject);
        });
      });
    }
  }]);

  return AwsSpotService;
}();

exports["default"] = AwsSpotService;